
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <helper_math.h>
#include <helper_cuda.h>

typedef unsigned int 	uint;
typedef unsigned char 	uchar;
typedef unsigned short 	ushort;

#include "CUDAFunc.cuh"

cudaArray * g_pCUDAArray = 0;

extern "C"
void initTexture(int nWidth, int nHeight, uchar * pData) {
	cudaChannelFormatDesc channelDesc = cudaCreateChannelDesc(16, 0,0,0,cudaChannelFormatKindUnsigned );
	bool bFirst = (0 == g_pCUDAArray);
	if (bFirst) {
		checkCudaErrors(cudaMallocArray(&g_pCUDAArray, &channelDesc, nWidth , nHeight));
	}
	uint nSize = nWidth * nHeight * sizeof (ushort);
	checkCudaErrors(cudaMemcpyToArray(g_pCUDAArray, 0, 0, pData, nSize, cudaMemcpyHostToDevice));
	
	if (bFirst) {
		g_tex.addressMode[0] = cudaAddressModeClamp;
		g_tex.addressMode[1] = cudaAddressModeClamp;
		g_tex.filterMode = cudaFilterModePoint;
		g_tex.normalized = false;
		
		checkCudaErrors(cudaBindTextureToArray(g_tex, g_pCUDAArray));
	}
}

extern "C" 
void cudaConvertBG10ToRGB(int nWidth, int nHeight,
		dim3 blockSize, dim3 gridSize, uchar4 * pOutput) {
	g_tex.filterMode = cudaFilterModePoint;
	render_bg10toRGB<<<gridSize, blockSize>>>(pOutput, nWidth, nHeight);
}