#ifndef _CUDAFUNC_CUH_
#define _CUDAFUNC_CUH_

//Declare texture
texture<ushort, 2, cudaReadModeElementType> g_tex;

#define SHIFT_SIZE 6


__global__ void
render_bg10toRGB(uchar4 * pOut, uint uWidth, uint uHeight) {
	uint uX = __umul24(blockIdx.x, blockDim.x) + threadIdx.x;
	uint uY = __umul24(blockIdx.y, blockDim.y) + threadIdx.y;
	uint uI = __umul24(uY, uWidth) + uX;

	float x = uX + 0.5f;
	float y = uY + 0.5f;

	int mode = (uY%2 << 1) | uX %2;
	uchar uRed = 0, uGreen = 0, uBlue = 0;

	if ((uX < uWidth) && (uY < uHeight)) {

		switch(mode) {
			case 0: {
				uGreen =  ((tex2D(g_tex, x - 1, y) >> SHIFT_SIZE) + (tex2D(g_tex, x + 1, y) >> SHIFT_SIZE) + (tex2D(g_tex, x, y - 1) >> SHIFT_SIZE) + (tex2D(g_tex, x, y + 1) >> SHIFT_SIZE))>>2;
				uRed	= ((tex2D(g_tex, x + 1, y - 1) >> SHIFT_SIZE) + (tex2D(g_tex, x-1, y + 1) >> SHIFT_SIZE) + (tex2D(g_tex, x-1, y-1) >> SHIFT_SIZE) + (tex2D(g_tex, x + 1, y + 1) >> SHIFT_SIZE)) >> 2;
				uBlue	= (tex2D(g_tex, x, y) >> SHIFT_SIZE);
			}break;

			case 1: {
				uRed	= ((tex2D(g_tex, x, y-1) >> SHIFT_SIZE) + (tex2D(g_tex, x, y + 1) >> SHIFT_SIZE))>>1;
				uGreen	= (tex2D(g_tex, x, y) >> SHIFT_SIZE);
				uBlue   = ((tex2D(g_tex, x - 1, y) >> SHIFT_SIZE) + (tex2D(g_tex, x + 1, y) >> SHIFT_SIZE))>>1;

			}break;
			case 2: {
				uRed   = ((tex2D(g_tex, x- 1, y) >> SHIFT_SIZE) + (tex2D(g_tex, x + 1, y) >> SHIFT_SIZE))>>1;
				uGreen	= (tex2D(g_tex, x, y) >> SHIFT_SIZE);
				uBlue	= ((tex2D(g_tex, x, y - 1) >> SHIFT_SIZE) + (tex2D(g_tex, x, y + 1) >> SHIFT_SIZE))>>1;

			}break;
			case 3: {
				uRed	= (tex2D(g_tex, x, y) >> SHIFT_SIZE);
				uGreen	= ((tex2D(g_tex, x - 1, y) >> SHIFT_SIZE) + (tex2D(g_tex, x + 1, y) >> SHIFT_SIZE) + (tex2D(g_tex, x, y - 1) >> SHIFT_SIZE) + (tex2D(g_tex, x, y + 1) >> SHIFT_SIZE))>>2;
				uBlue	= ((tex2D(g_tex, x - 1, y - 1) >> SHIFT_SIZE) + (tex2D(g_tex, x + 1, y - 1) >> SHIFT_SIZE) + (tex2D(g_tex, x - 1, y + 1) >> SHIFT_SIZE) + (tex2D(g_tex, x + 1, y + 1) >> SHIFT_SIZE))>>2;

			}break;
		}

		pOut[uI] = make_uchar4(uRed, uGreen, uBlue, 0);
	}
}

#endif
